diff --git a/doc/NEWS b/doc/NEWS
index 8e4f293f7f..06f7e69ec2 100644
--- a/doc/NEWS
+++ b/doc/NEWS
@@ -60,6 +60,10 @@ Major changes from 1.9.0-jumbo-1 (May 2019) in this bleeding-edge version:
   --format=#ipmi-opencl  will pick the RAKP-opencl format.  We already had
   the '@' symbol for searching in alorithm name.  [magnum; 2019]
 
+- Worked out a new KISS solution "FMT_BLOB" for non-hash formats, so they can
+  still benefit from same-salt optimizations/exploits.  [magnum; 2019]
+
+
 Major changes from 1.8.0-jumbo-1 (December 2014) to 1.9.0-jumbo-1 (May 2019):
 
 - Updated to 1.9.0 core, which brought the following relevant major changes:
diff --git a/src/bench.c b/src/bench.c
index ed9ed2282e..95e317a81b 100644
--- a/src/bench.c
+++ b/src/bench.c
@@ -431,7 +431,13 @@ char *benchmark_format(struct fmt_main *format, int salts,
 	if (format->params.binary_size > binary_size) {
 		binary_size = format->params.binary_size;
 		binary = mem_alloc_tiny(binary_size, MEM_ALIGN_SIMD);
-		memset(binary, 0x55, binary_size);
+		if (format->params.flags & FMT_BLOB) {
+			/* For this case we'd ideally use two_binaries[2] */
+			memcpy(binary,
+			       format->methods.binary(format->params.tests[0].ciphertext),
+			       binary_size);
+		} else
+			memset(binary, 0x55, binary_size);
 	}
 
 	for (index = 0; index < 2; index++) {
@@ -607,6 +613,8 @@ char *benchmark_format(struct fmt_main *format, int salts,
 	          (salts_done < (wait ? salts : MIN(salts, 2))) ||
 	          (10 * salts_done > 9 * salts && salts_done < salts)));
 
+	BLOB_FREE(format, binary);
+
 #if defined (__MINGW32__) || defined (_MSC_VER)
 	end_real = clock();
 #else
diff --git a/src/cracker.c b/src/cracker.c
index 8ccc5b26d6..78f31da518 100644
--- a/src/cracker.c
+++ b/src/cracker.c
@@ -303,6 +303,7 @@ static void crk_remove_hash(struct db_salt *salt, struct db_password *pw)
 		while (*current != pw)
 			current = &(*current)->next;
 		*current = pw->next;
+		BLOB_FREE(crk_db->format, pw->binary);
 		pw->binary = NULL;
 		return;
 	}
@@ -347,8 +348,10 @@ static void crk_remove_hash(struct db_salt *salt, struct db_password *pw)
  * Or, if FMT_REMOVE, the format explicitly intends to traverse the list
  * during cracking, and will remove entries at that point.
  */
-	if (crk_guesses || (crk_params->flags & FMT_REMOVE))
+	if (crk_guesses || (crk_params->flags & FMT_REMOVE)) {
+		BLOB_FREE(crk_db->format, pw->binary);
 		pw->binary = NULL;
+	}
 }
 
 /* Negative index is not counted/reported (got it from pot sync) */
@@ -410,7 +413,7 @@ static int crk_process_guess(struct db_salt *salt, struct db_password *pw,
 	}
 
 	// Ok, FIX the salt  ONLY if -regen-lost-salts=X was used.
-	if (options.regen_lost_salts && (crk_db->format->params.flags & FMT_DYNAMIC) == FMT_DYNAMIC)
+	if (options.regen_lost_salts && (crk_params->flags & FMT_DYNAMIC) == FMT_DYNAMIC)
 		crk_guess_fixup_salt(pw->source, *(char**)(salt->salt));
 
 	/* If we got this crack from a pot sync, don't report or count */
@@ -430,7 +433,7 @@ static int crk_process_guess(struct db_salt *salt, struct db_password *pw,
 			john_max_cands = status.cands - options.max_cands +
 				crk_params->max_keys_per_crypt;
 
-		if (dupe)
+		if (dupe && !(crk_params->flags & FMT_BLOB))
 			ct = NULL;
 		else
 			ct = ldr_pot_source(
@@ -492,7 +495,6 @@ static int crk_remove_pot_entry(char *ciphertext)
 	struct db_password *pw;
 	char argcopy[LINE_BUFFER_SIZE];
 	void *pot_salt;
-	char *binary = crk_methods.binary(ciphertext);
 
 	/*
 	 * If the pot entry is truncated from a huge ciphertext, we have
@@ -567,8 +569,10 @@ static int crk_remove_pot_entry(char *ciphertext)
 	}
 	else {
 		int hash;
+		char *binary = crk_methods.binary(ciphertext);
 
 		hash = crk_methods.binary_hash[salt->hash_size](binary);
+		BLOB_FREE(crk_db->format, binary);
 		if (!(salt->bitmap[hash / (sizeof(*salt->bitmap) * 8)] &
 		      (1U << (hash % (sizeof(*salt->bitmap) * 8)))))
 			return 0;
diff --git a/src/formats.c b/src/formats.c
index 480b009ee2..3ae09cda4d 100644
--- a/src/formats.c
+++ b/src/formats.c
@@ -239,6 +239,8 @@ static char* is_key_right(struct fmt_main *format, int index,
 
 	for (size = 0; size < PASSWORD_HASH_SIZES; size++)
 	if (format->methods.binary_hash[size] &&
+	    format->methods.get_hash[size] &&
+	    format->methods.get_hash[size] != fmt_default_get_hash &&
 	    format->methods.get_hash[size](i) !=
 	    format->methods.binary_hash[size](binary)) {
 		if (options.verbosity > VERB_LEGACY) {
@@ -327,6 +329,23 @@ static char* is_key_right(struct fmt_main *format, int index,
 }
 #endif
 
+int fmt_bincmp(void *b1, void *b2, struct fmt_main *format)
+{
+	if (!(format->params.flags & FMT_BLOB))
+		return memcmp(b1, b2, format->params.binary_size);
+
+	size_t s1 = ((fmt_data*)b1)->size;
+	size_t s2 = ((fmt_data*)b2)->size;
+
+	if (s1 != s2)
+		return 1;
+
+	b1 = ((fmt_data*)b1)->blob;
+	b2 = ((fmt_data*)b2)->blob;
+
+	return memcmp(b1, b2, s1);
+}
+
 static char *fmt_self_test_body(struct fmt_main *format,
     void *binary_copy, void *salt_copy, struct db_main *db, int full_lvl)
 {
@@ -473,10 +492,18 @@ static char *fmt_self_test_body(struct fmt_main *format,
 
 	if (format->params.flags & FMT_HUGE_INPUT) {
 		for (size = 0; size < PASSWORD_HASH_SIZES; size++) {
+#if 0
+			/*
+			 * We should allow this! The trick is it should calculate the
+			 * same MD5 as the $SOURCE_HASH$ and return a portion of that.
+			 * The self-test should instead confirm that a truncated pot
+			 * hash gets the same hash.
+			 */
 			if (format->methods.binary_hash[size] &&
 			    format->methods.binary_hash[size] !=
 			    fmt_default_binary_hash)
 				return "binary_hash method not allowed for FMT_HUGE_INPUT";
+#endif
 			if (format->methods.get_hash[size] &&
 			    format->methods.get_hash[size] !=
 			    fmt_default_get_hash)
@@ -523,6 +550,10 @@ static char *fmt_self_test_body(struct fmt_main *format,
 	    !(format->params.flags & FMT_8_BIT))
 		return "FMT_UNICODE without FMT_8_BIT";
 
+	if ((format->params.flags & FMT_BLOB) &&
+	    (format->params.binary_size != sizeof(fmt_data)))
+		return "FMT_BLOB with incorrect binary size";
+
 	if ((format->methods.binary == fmt_default_binary) &&
 	    (format->params.binary_size > 0))
 		return "Using default binary() with a non-zero BINARY_SIZE";
@@ -647,10 +678,12 @@ static char *fmt_self_test_body(struct fmt_main *format,
 
 		/* validate that binary() returns cleaned buffer */
 		if (extra_tests && !binary_cleaned_warned && format->params.binary_size) {
+			BLOB_FREE(format, binary);
 			memset(binary, 0xAF, format->params.binary_size);
 			binary = format->methods.binary(ciphertext);
 			if (((unsigned char*)binary)[format->params.binary_size-1] == 0xAF)
 			{
+				BLOB_FREE(format, binary);
 				memset(binary, 0xCC, format->params.binary_size);
 				binary = format->methods.binary(ciphertext);
 				if (((unsigned char*)binary)[format->params.binary_size-1] == 0xCC)
@@ -661,6 +694,7 @@ static char *fmt_self_test_body(struct fmt_main *format,
 				}
 			}
 			/* Clean up the mess we might have caused */
+			BLOB_FREE(format, binary);
 			memset(binary, 0, format->params.binary_size);
 			binary = format->methods.binary(ciphertext);
 		}
@@ -854,6 +888,7 @@ static char *fmt_self_test_body(struct fmt_main *format,
 		if (full_lvl >= 0) {
 #ifndef BENCH_BUILD
 			ret = is_key_right(format, max - 1, binary, ciphertext, plaintext, 0, dbsalt);
+			BLOB_FREE(format, binary);
 			if (ret)
 				return ret;
 #endif
@@ -863,49 +898,50 @@ static char *fmt_self_test_body(struct fmt_main *format,
 		} else {
 #ifndef BENCH_BUILD
 			ret = is_key_right(format, index, binary, ciphertext, plaintext, 0, dbsalt);
-		if (ret)
-			return ret;
+			BLOB_FREE(format, binary);
+			if (ret)
+				return ret;
 #endif
 /* Remove some old keys to better test cmp_all() */
-		if (index & 1) {
-			format->methods.clear_keys();
-			for (i = 0; i <= index; i++)
-				fmt_set_key(fmt_null_key, i);
-		}
+			if (index & 1) {
+				format->methods.clear_keys();
+				for (i = 0; i <= index; i++)
+					fmt_set_key(fmt_null_key, i);
+			}
 
 /* 0 1 2 3 4 6 9 13 19 28 42 63 94 141 211 316 474 711 1066 ... */
-		if (index >= 2 && max > ntests) {
+			if (index >= 2 && max > ntests) {
 /* Always call set_key() even if skipping. Some formats depend on it. */
-			for (i = index + 1;
-			     i < max && i < (index + (index >> 1)); i++)
-				fmt_set_key(longcand(format, i, sl), i);
-			index = i;
-		} else
-			index++;
-
-		if (index >= max) {
-			format->methods.clear_keys();
-			index = (max > 5 && max > ntests && done != 1) ? 5 : 0;
+				for (i = index + 1;
+				     i < max && i < (index + (index >> 1)); i++)
+					fmt_set_key(longcand(format, i, sl), i);
+				index = i;
+			} else
+				index++;
+
+			if (index >= max) {
+				format->methods.clear_keys();
+				index = (max > 5 && max > ntests && done != 1) ? 5 : 0;
 /* Always call set_key() even if skipping. Some formats depend on it. */
-			for (i = 0; i < index; i++)
-				fmt_set_key(longcand(format, i, sl), i);
-			done |= 1;
-		}
+				for (i = 0; i < index; i++)
+					fmt_set_key(longcand(format, i, sl), i);
+				done |= 1;
+			}
 
-		if (!(++current)->ciphertext) {
+			if (!(++current)->ciphertext) {
 #if defined(HAVE_OPENCL)
 /* Jump straight to last index for GPU formats but always call set_key() */
-			if (strstr(format->params.label, "-opencl")) {
-				for (i = index + 1; i < max - 1; i++)
-				    fmt_set_key(longcand(format, i, sl), i);
-				index = max - 1;
-			}
+				if (strstr(format->params.label, "-opencl")) {
+					for (i = index + 1; i < max - 1; i++)
+						fmt_set_key(longcand(format, i, sl), i);
+					index = max - 1;
+				}
 #endif
-			current = format->params.tests;
-			done |= 2;
-		}
-		dyna_salt_remove(salt);
-		while_condition = done != 3;
+				current = format->params.tests;
+				done |= 2;
+			}
+			dyna_salt_remove(salt);
+			while_condition = done != 3;
 		}
 	} while (while_condition);
 
@@ -1195,9 +1231,11 @@ static void test_fmt_split_unifies_case(struct fmt_main *format, char *ciphertex
 		ret = format->methods.split(ret, 0, format);
 		ret_copy = strdup(ret);
 		bin = format->methods.binary(ret_copy);
-		if (format->params.binary_size>4) {
-			bin_hex = mem_alloc(format->params.binary_size*2+1);
-			base64_convert(bin, e_b64_raw, format->params.binary_size, bin_hex, e_b64_hex, format->params.binary_size*2+1, 0, 0);
+		if (BLOB_SIZE(format, bin) > 4) {
+			bin_hex = mem_alloc(BLOB_SIZE(format, bin) * 2 + 1);
+			base64_convert(BLOB_BINARY(format, bin), e_b64_raw,
+			               BLOB_SIZE(format, bin), bin_hex, e_b64_hex,
+			               BLOB_SIZE(format, bin) * 2 + 1, 0, 0);
 			cp = strstr(ret_copy, bin_hex);
 			strupr(bin_hex);
 			if (cp) {
@@ -1219,6 +1257,7 @@ static void test_fmt_split_unifies_case(struct fmt_main *format, char *ciphertex
 			}
 			MEM_FREE(bin_hex);
 		}
+		BLOB_FREE(format, bin);
 		if (format->params.salt_size>4 && format->params.salt_size < strlen(ret_copy)-10) {
 			bin_hex = mem_alloc(format->params.salt_size*2+1);
 			bin = format->methods.salt(ret_copy);
@@ -1357,18 +1396,19 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 	orig_salt = NULL;
 
 	binary = format->methods.binary(split_ret);
-	if (binary != NULL) {
-
-		orig_binary = mem_alloc(format->params.binary_size);
-		memcpy(orig_binary, binary, format->params.binary_size);
+	if (binary) {
+		orig_binary = mem_alloc(BLOB_SIZE(format, binary));
+		memcpy(orig_binary, BLOB_BINARY(format, binary),
+		       BLOB_SIZE(format, binary));
 
 		salt = format->methods.salt(split_ret);
 		dyna_salt_create(salt);
-		if (salt != NULL && format->params.salt_size) {
+		if (salt && format->params.salt_size) {
 			orig_salt = mem_alloc(format->params.salt_size);
 			memcpy(orig_salt, salt, format->params.salt_size);
 		}
 		dyna_salt_remove(salt);
+		BLOB_FREE(format, binary);
 	}
 
 /*
@@ -1400,12 +1440,12 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 				*is_need_unify_case = 0;
 			binary = format->methods.binary(split_ret);
 
-			if (binary != NULL)
-			if (memcmp(orig_binary, binary, format->params.binary_size) != 0) {
+			if (binary && fmt_bincmp(orig_binary, binary, format)) {
 				// Do not need to unify cases in split() and add
 				// FMT_SPLIT_UNIFIES_CASE
 				*is_need_unify_case = 0;
 			}
+			BLOB_FREE(format, binary);
 		} else
 			*is_need_unify_case = 0;
 	}
@@ -1422,12 +1462,12 @@ static void test_fmt_split_unifies_case_3(struct fmt_main *format,
 				*is_need_unify_case = 0;
 			binary = format->methods.binary(split_ret);
 
-			if (binary != NULL)
-			if (memcmp(orig_binary, binary, format->params.binary_size) != 0) {
+			if (binary && fmt_bincmp(orig_binary, binary, format)) {
 				// Do not need to unify cases in split() and add
 				// FMT_SPLIT_UNIFIES_CASE
 				*is_need_unify_case = 0;
 			}
+			BLOB_FREE(format, binary);
 		} else
 			*is_need_unify_case = 0;
 	}
@@ -1580,6 +1620,7 @@ char *fmt_self_test(struct fmt_main *format, struct db_main *db)
 
 	binary_copy = alloc_binary(&binary_alloc,
 	    format->params.binary_size?format->params.binary_size:1, format->params.binary_align);
+	memset(binary_copy, 0, format->params.binary_size);
 	salt_copy = alloc_binary(&salt_alloc,
 	    format->params.salt_size?format->params.salt_size:1, format->params.salt_align);
 
diff --git a/src/formats.h b/src/formats.h
index 0ba3143112..cb8ae4eb5e 100644
--- a/src/formats.h
+++ b/src/formats.h
@@ -118,6 +118,8 @@ struct db_salt;
 #define FMT_OMP				0
 #define FMT_OMP_BAD			0
 #endif
+/* Non-hash format. If used, binary_size must be sizeof(fmt_data) */
+#define FMT_BLOB			0x04000000
 /* We've already warned the user about hashes of this type being present */
 #define FMT_WARNED			0x80000000
 
@@ -132,6 +134,57 @@ struct fmt_tests {
 	char *fields[10];
 };
 
+#define BLOB_DEBUG	1
+/* Magic signature, stuffed in flags for debugging */
+#if BLOB_DEBUG
+#include <assert.h>
+#define FMT_DATA_MAGIC	((sizeof(size_t) < 8) ? 0x0babe500 : \
+					0x00c007000babe500ULL)
+#define BLOB_ASSERT(b)	assert((((fmt_data*)(b))->flags & ~3) == FMT_DATA_MAGIC)
+#else
+#define BLOB_ASSERT(b)
+#define FMT_DATA_MAGIC	0
+#endif /* BLOB_DEBUG */
+
+/*
+ * Flags for fmt_data.
+ */
+/* Blob portion is tiny-alloc. */
+#define FMT_DATA_TINY			(FMT_DATA_MAGIC | 0x01)
+/* Blob portion is malloc, so needs to be freed when done with it. */
+#define FMT_DATA_ALLOC			(FMT_DATA_MAGIC | 0x02)
+
+/*
+ * Variable size data for non-hashes (formerly stored in "salt").
+ * "size" is the size of blob only. Size of data returned is always
+ * just sizeof(fmt_data). The blob is either mem_alloc_tiny and flag
+ * is FMT_DATA_TINY, or alloced and flag is FMT_DATA_ALLOC.
+ * The latter needs free when we're done with it. Regardless, the
+ * loader never copies it - just this struct. The cracker uses the
+ * pointer and size (and frees the pointer when appropriate).
+ */
+typedef struct {
+	size_t flags;
+	size_t size;
+	void *blob;
+} fmt_data;
+
+/* Helper macros */
+#define BLOB_BINARY(f, b) (((f)->params.flags & FMT_BLOB) ?	\
+                        (((fmt_data*)(b))->blob) : (b))
+
+#define BLOB_SIZE(f, b) (((f)->params.flags & FMT_BLOB) ?	  \
+                      (((fmt_data*)(b))->size) : ((f)->params.binary_size))
+
+#define BLOB_FREE(f, b) do {	  \
+		if ((f)->params.flags & FMT_BLOB) { \
+			BLOB_ASSERT(b); \
+			if ((b) && \
+			    (((fmt_data*)(b))->flags & (FMT_DATA_ALLOC & 3))) \
+				MEM_FREE(((fmt_data*)(b))->blob); \
+		} \
+	} while (0)
+
 /*
  * Parameters of a hash function and its cracking algorithm.
  */
@@ -246,6 +299,7 @@ struct fmt_methods {
 	char *(*split)(char *ciphertext, int index, struct fmt_main *self);
 
 /* Converts an ASCII ciphertext to binary, possibly using the salt */
+/* Or, converts an ASCII non-hash data blob to a fmt_data struct */
 	void *(*binary)(char *ciphertext);
 
 /* Converts an ASCII salt to its internal representation */
@@ -408,6 +462,13 @@ extern void fmt_all_done(void);
  */
 extern char *fmt_self_test(struct fmt_main *format, struct db_main *db);
 
+/*
+ * Compare the real binary, whatever it is:
+ * If this is not FMT_BLOB we do a plain memcmp. If it is, we
+ * memcmp the pointed-to binaries, with correct sizes.
+ */
+extern int fmt_bincmp(void *b1, void *b2, struct fmt_main *format);
+
 /*
  * Default methods.
  */
diff --git a/src/john.c b/src/john.c
index 2353156a2a..3da39d1c68 100644
--- a/src/john.c
+++ b/src/john.c
@@ -1141,10 +1141,21 @@ static void load_extra_pots(struct db_main *db, void (*process_file)(struct db_m
 static void db_main_free(struct db_main *db)
 {
 	if (db->format &&
-		(db->format->params.flags & FMT_DYNA_SALT) == FMT_DYNA_SALT) {
+	    (db->format->params.flags & (FMT_DYNA_SALT | FMT_BLOB))) {
 		struct db_salt *psalt = db->salts;
 		while (psalt) {
-			dyna_salt_remove(psalt->salt);
+			struct db_password *pw = psalt->list;
+
+			if ((db->format->params.flags & FMT_BLOB) && pw &&
+			    pw->binary &&
+			    ((fmt_data*)pw->binary)->flags == FMT_DATA_ALLOC) {
+				do {
+					fmt_data *bin = pw->binary;
+					BLOB_FREE(db->format, bin);
+				} while ((pw = pw->next));
+			}
+			if (db->format->params.flags & FMT_DYNA_SALT)
+				dyna_salt_remove(psalt->salt);
 			psalt = psalt->next;
 		}
 	}
diff --git a/src/loader.c b/src/loader.c
index f9aee50adf..f41fe4cb53 100644
--- a/src/loader.c
+++ b/src/loader.c
@@ -949,16 +949,17 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 		if (options.flags & FLG_REJECT_PRINTABLE) {
 			int i = 0;
 
-			while (isprint((int)((unsigned char*)binary)[i]) &&
-			       i < format->params.binary_size)
+			while (isprint((int)((uint8_t*)BLOB_BINARY(format, binary))[i]) &&
+			       i < BLOB_SIZE(format, binary))
 				i++;
 
-			if (i == format->params.binary_size) {
+			if (i == BLOB_SIZE(format, binary)) {
 				if (john_main_process)
 				fprintf(stderr, "rejecting printable binary"
 				        " \"%.*s\" (%s)\n",
-				        format->params.binary_size,
-				        (char*)binary, piece);
+				        (int)BLOB_SIZE(format, binary),
+				        (char*)BLOB_BINARY(format, binary), piece);
+				BLOB_FREE(format, binary);
 				continue;
 			}
 		}
@@ -967,8 +968,7 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 			int collisions = 0;
 			if ((current_pw = db->password_hash[pw_hash]))
 			do {
-				if (!memcmp(binary, current_pw->binary,
-				    format->params.binary_size) &&
+				if (!fmt_bincmp(binary, current_pw->binary, format) &&
 				    !strcmp(piece, format->methods.source(
 				    current_pw->source, current_pw->binary))) {
 					db->options->flags |= DB_NODUP;
@@ -997,7 +997,10 @@ static void ldr_load_pw_line(struct db_main *db, char *line)
 				break;
 			} while ((current_pw = current_pw->next_hash));
 
-			if (current_pw) continue;
+			if (current_pw) {
+				BLOB_FREE(format, binary);
+				continue;
+			}
 		}
 
 		salt = format->methods.salt(piece);
@@ -1181,7 +1184,8 @@ static void ldr_load_pot_line(struct db_main *db, char *line)
 	struct db_password *current;
 
 	ciphertext = ldr_get_field(&line, db->options->field_sep_char);
-	if (ldr_trunc_valid(ciphertext, format) != 1) return;
+	if (ldr_trunc_valid(ciphertext, format) != 1)
+		return;
 	ciphertext = format->methods.split(ciphertext, 0, format);
 	binary = format->methods.binary(ciphertext);
 	hash = db->password_hash_func(binary);
@@ -1199,17 +1203,19 @@ static void ldr_load_pot_line(struct db_main *db, char *line)
 		 * can't treat with memcmp().
 		 */
 		if (hash || !ldr_isa_pot_source(ciphertext))
-		if (memcmp(binary, current->binary, format->params.binary_size))
+		if (fmt_bincmp(binary, current->binary, format))
 			continue;
 		if (ldr_pot_source_cmp(ciphertext,
 		    format->methods.source(current->source, current->binary)))
 			continue;
+		BLOB_FREE(format, current->binary);
 		current->binary = NULL; /* mark for removal */
 		need_removal = 1;
 	} while ((current = current->next_hash));
 
 	if (need_removal)
 		db->options->flags |= DB_NEED_REMOVAL;
+	BLOB_FREE(format, binary);
 }
 
 struct db_main *ldr_init_test_db(struct fmt_main *format, struct db_main *real)
@@ -1285,11 +1291,21 @@ void ldr_free_test_db(struct db_main *db)
 {
 	if (db) {
 		if (db->format &&
-		    (db->format->params.flags & FMT_DYNA_SALT) == FMT_DYNA_SALT)
-		{
+		    (db->format->params.flags & (FMT_DYNA_SALT | FMT_BLOB))) {
 			struct db_salt *psalt = db->salts;
 			while (psalt) {
-				dyna_salt_remove(psalt->salt);
+				struct db_password *pw = psalt->list;
+
+				if ((db->format->params.flags & FMT_BLOB) &&
+				    pw && pw->binary &&
+				    ((fmt_data*)pw->binary)->flags == FMT_DATA_ALLOC) {
+					do {
+						fmt_data *bin = pw->binary;
+						BLOB_FREE(db->format, bin);
+					} while ((pw = pw->next));
+				}
+				if (db->format->params.flags & FMT_DYNA_SALT)
+					dyna_salt_remove(psalt->salt);
 				psalt = psalt->next;
 			}
 		}
@@ -1473,7 +1489,7 @@ static void ldr_sort_salts(struct db_main *db)
 	dyna_salt_init(db->format);
 	if (fmt_salt_compare)
 		qsort(ar, db->salt_count, sizeof(ar[0]), ldr_salt_cmp);
-	else /* Most used salt first */
+	else /* Default sort function, ensuring salt resume works if possible */
 		qsort(ar, db->salt_count, sizeof(ar[0]), ldr_salt_cmp_num);
 
 	/* Reset salt hash table, if we still have one */
@@ -1687,6 +1703,15 @@ static void ldr_init_hash_for_salt(struct db_main *db, struct db_salt *salt)
 		return;
 	}
 
+	do {
+		int (*get_func)(int index);
+
+		get_func = db->format->methods.get_hash[salt->hash_size];
+		if (get_func && get_func != fmt_default_get_hash)
+			break;
+		salt->hash_size--;
+	} while (salt->hash_size > 0);
+
 	bitmap_size = password_hash_sizes[salt->hash_size];
 	{
 		size_t size = (bitmap_size +
@@ -1752,7 +1777,10 @@ static void ldr_init_hash(struct db_main *db)
 				    password_hash_thresholds[size] &&
 				    db->format->methods.binary_hash[size] &&
 				    db->format->methods.binary_hash[size] !=
-				    fmt_default_binary_hash)
+				    fmt_default_binary_hash &&
+				    db->format->methods.get_hash[size] &&
+				    db->format->methods.get_hash[size] !=
+					fmt_default_get_hash)
 					break;
 
 		if (mem_saving_level >= 2)
diff --git a/src/loader.h b/src/loader.h
index 8ea5c5aa0a..30cbf8f250 100644
--- a/src/loader.h
+++ b/src/loader.h
@@ -26,7 +26,9 @@ struct db_password {
 /* Pointer to next password hash with the same salt */
 	struct db_password *next;
 
-/* Hot portion of or full binary ciphertext for fast comparison (aligned) */
+/* Hot portion of or full binary ciphertext for fast comparison (aligned).
+ * Alternatively, for non-hash formats: Non-salt data (that we used to
+ * incorrectly store in a "salt"). */
 	void *binary;
 
 /* After loading is completed: pointer to next password hash with the same salt
diff --git a/src/opencl_common.c b/src/opencl_common.c
index 859040eec1..b45a0fab80 100644
--- a/src/opencl_common.c
+++ b/src/opencl_common.c
@@ -6,7 +6,7 @@
  * This software is
  * Copyright (c) 2010-2012 Samuele Giovanni Tonon <samu at linuxasylum dot net>
  * Copyright (c) 2010-2013 Lukas Odzioba <ukasz@openwall.net>
- * Copyright (c) 2010-2015 magnum
+ * Copyright (c) 2010-2019 magnum
  * Copyright (c) 2012-2015 Claudio André <claudioandre.br at gmail.com>
  *
  * and is hereby released to the general public under the following terms:
@@ -1608,7 +1608,19 @@ static cl_ulong gws_test(size_t gws, unsigned int rounds, int sequential_id)
 			dyna_salt_remove(salt);
 		return 0;
 	}
-	self->methods.cmp_all(binary, result);
+	result = self->methods.cmp_all(binary, result);
+	BLOB_FREE(self, binary);
+	if (result < 0) {
+		runtime = looptime = 0;
+
+		if (options.verbosity > VERB_LEGACY)
+			fprintf(stderr, " (error occurred)");
+		clear_profiling_events();
+		release_clobj();
+		if (!self->methods.tunable_cost_value[0] || !ocl_autotune_db->real)
+			dyna_salt_remove(salt);
+		return 0;
+	}
 
 	for (i = 0; (*multi_profilingEvent[i]); i++)
 		number_of_events++;
@@ -1852,7 +1864,11 @@ void opencl_find_best_lws(size_t group_size_limit, int sequential_id,
 				startTime = endTime = 0;
 				break;
 			}
-			self->methods.cmp_all(binary, result);
+			result = self->methods.cmp_all(binary, result);
+			if (result < 0) {
+				startTime = endTime = 0;
+				break;
+			}
 
 			HANDLE_CLERROR(clWaitForEvents(1, &benchEvent[main_opencl_event]),
 			               "clWaitForEvents");
@@ -1901,6 +1917,7 @@ void opencl_find_best_lws(size_t group_size_limit, int sequential_id,
 			}
 		}
 	}
+	BLOB_FREE(self, binary);
 	// Release profiling queue and create new with profiling disabled
 	HANDLE_CLERROR(clReleaseCommandQueue(queue[sequential_id]),
 	               "clReleaseCommandQueue");
